"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
exports.UnifiCameraAccessoryInfo = void 0;
class UnifiCameraAccessoryInfo {
    static createAccessoryInfo(camera, accessory, hap) {
        const cameraAccessoryInfo = accessory.getService(hap.Service.AccessoryInformation);
        if (cameraAccessoryInfo) {
            cameraAccessoryInfo.setCharacteristic(hap.Characteristic.Manufacturer, 'Ubiquiti');
            if (camera.type) {
                cameraAccessoryInfo.setCharacteristic(hap.Characteristic.Model, camera.type);
            }
            if (camera.mac) {
                cameraAccessoryInfo.setCharacteristic(hap.Characteristic.SerialNumber, camera.mac);
            }
            if (camera.firmware) {
                cameraAccessoryInfo.setCharacteristic(hap.Characteristic.FirmwareRevision, camera.firmware);
            }
        }
        return cameraAccessoryInfo;
    }
}
exports.UnifiCameraAccessoryInfo = UnifiCameraAccessoryInfo;
//# sourceMappingURL=unifi-camera-accessory-info.js.map